(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (factory((global.Taro = {})));
}(this, (function (exports) { 'use strict';

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  var ENV_TYPE = {
    WEAPP: 'WEAPP',
    WEB: 'WEB',
    RN: 'RN'
  };
  function getEnv() {
    if (typeof wx !== 'undefined' && wx.getSystemInfo) {
      return ENV_TYPE.WEAPP;
    }

    if (typeof window !== 'undefined') {
      return ENV_TYPE.WEB;
    }

    if (typeof global !== 'undefined' && global.ErrorUtils) {
      return ENV_TYPE.RN;
    }

    return 'Unknown environment';
  }
  function isEmptyObject(obj) {
    if (!obj) {
      return false;
    }

    for (var n in obj) {
      if (obj.hasOwnProperty(n) && obj[n]) {
        return false;
      }
    }

    return true;
  }
  function getPrototype(obj) {
    /* eslint-disable */
    if (Object.getPrototypeOf) {
      return Object.getPrototypeOf(obj);
    } else if (obj.__proto__) {
      return obj.__proto__;
    }
    /* eslint-enable */


    return obj.constructor.prototype;
  }
  function getPrototypeChain(obj) {
    var protoChain = [];

    while (obj = getPrototype(obj)) {
      protoChain.push(obj);
    }

    return protoChain;
  }

  var nextTick = function nextTick(fn) {
    var _fn;

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    fn = typeof fn === 'function' ? (_fn = fn).bind.apply(_fn, [null].concat(args)) : fn;
    var timerFunc = setTimeout;
    timerFunc(fn);
  };

  /* eslint-disable */

  /**
   * lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="npm" -o ./`
   * Copyright jQuery Foundation and other contributors <https://jquery.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   */

  /** Used as the `TypeError` message for "Functions" methods. */
  var FUNC_ERROR_TEXT = 'Expected a function';
  /** Used to stand-in for `undefined` hash values. */

  var HASH_UNDEFINED = '__lodash_hash_undefined__';
  /** Used as references for various `Number` constants. */

  var INFINITY = 1 / 0;
  /** `Object#toString` result references. */

  var funcTag = '[object Function]',
      genTag = '[object GeneratorFunction]',
      symbolTag = '[object Symbol]';
  /** Used to match property names within property paths. */

  var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
      reIsPlainProp = /^\w*$/,
      reLeadingDot = /^\./,
      rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
  /**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */

  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
  /** Used to match backslashes in property paths. */

  var reEscapeChar = /\\(\\)?/g;
  /** Used to detect host constructors (Safari). */

  var reIsHostCtor = /^\[object .+?Constructor\]$/;
  /** Detect free variable `global` from Node.js. */

  var freeGlobal = (typeof global === "undefined" ? "undefined" : _typeof(global)) === 'object' && global && global.Object === Object && global;
  /** Detect free variable `self`. */

  var freeSelf = (typeof self === "undefined" ? "undefined" : _typeof(self)) === 'object' && self && self.Object === Object && self;
  /** Used as a reference to the global object. */

  var root = freeGlobal || freeSelf || Function('return this')();
  /**
   * Gets the value at `key` of `object`.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */

  function getValue(object, key) {
    return object == null ? undefined : object[key];
  }
  /**
   * Checks if `value` is a host object in IE < 9.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
   */


  function isHostObject(value) {
    // Many host objects are `Object` objects that can coerce to strings
    // despite having improperly defined `toString` methods.
    var result = false;

    if (value != null && typeof value.toString !== 'function') {
      try {
        result = !!(value + '');
      } catch (e) {}
    }

    return result;
  }
  /** Used for built-in method references. */


  var arrayProto = Array.prototype,
      funcProto = Function.prototype,
      objectProto = Object.prototype;
  /** Used to detect overreaching core-js shims. */

  var coreJsData = root['__core-js_shared__'];
  /** Used to detect methods masquerading as native. */

  var maskSrcKey = function () {
    var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
    return uid ? 'Symbol(src)_1.' + uid : '';
  }();
  /** Used to resolve the decompiled source of functions. */


  var funcToString = funcProto.toString;
  /** Used to check objects for own properties. */

  var hasOwnProperty = objectProto.hasOwnProperty;
  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */

  var objectToString = objectProto.toString;
  /** Used to detect if a method is native. */

  var reIsNative = RegExp('^' + funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');
  /** Built-in value references. */

  var _Symbol = root.Symbol,
      splice = arrayProto.splice;
  /* Built-in method references that are verified to be native. */

  var Map$1 = getNative(root, 'Map'),
      nativeCreate = getNative(Object, 'create');
  /** Used to convert symbols to primitives and strings. */

  var symbolProto = _Symbol ? _Symbol.prototype : undefined,
      symbolToString = symbolProto ? symbolProto.toString : undefined;
  /**
   * Creates a hash object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */

  function Hash(entries) {
    var index = -1,
        length = entries ? entries.length : 0;
    this.clear();

    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  /**
   * Removes all key-value entries from the hash.
   *
   * @private
   * @name clear
   * @memberOf Hash
   */


  function hashClear() {
    this.__data__ = nativeCreate ? nativeCreate(null) : {};
  }
  /**
   * Removes `key` and its value from the hash.
   *
   * @private
   * @name delete
   * @memberOf Hash
   * @param {Object} hash The hash to modify.
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */


  function hashDelete(key) {
    return this.has(key) && delete this.__data__[key];
  }
  /**
   * Gets the hash value for `key`.
   *
   * @private
   * @name get
   * @memberOf Hash
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */


  function hashGet(key) {
    var data = this.__data__;

    if (nativeCreate) {
      var result = data[key];
      return result === HASH_UNDEFINED ? undefined : result;
    }

    return hasOwnProperty.call(data, key) ? data[key] : undefined;
  }
  /**
   * Checks if a hash value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Hash
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */


  function hashHas(key) {
    var data = this.__data__;
    return nativeCreate ? data[key] !== undefined : hasOwnProperty.call(data, key);
  }
  /**
   * Sets the hash `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Hash
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the hash instance.
   */


  function hashSet(key, value) {
    var data = this.__data__;
    data[key] = nativeCreate && value === undefined ? HASH_UNDEFINED : value;
    return this;
  } // Add methods to `Hash`.


  Hash.prototype.clear = hashClear;
  Hash.prototype['delete'] = hashDelete;
  Hash.prototype.get = hashGet;
  Hash.prototype.has = hashHas;
  Hash.prototype.set = hashSet;
  /**
   * Creates an list cache object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */

  function ListCache(entries) {
    var index = -1,
        length = entries ? entries.length : 0;
    this.clear();

    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  /**
   * Removes all key-value entries from the list cache.
   *
   * @private
   * @name clear
   * @memberOf ListCache
   */


  function listCacheClear() {
    this.__data__ = [];
  }
  /**
   * Removes `key` and its value from the list cache.
   *
   * @private
   * @name delete
   * @memberOf ListCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */


  function listCacheDelete(key) {
    var data = this.__data__,
        index = assocIndexOf(data, key);

    if (index < 0) {
      return false;
    }

    var lastIndex = data.length - 1;

    if (index == lastIndex) {
      data.pop();
    } else {
      splice.call(data, index, 1);
    }

    return true;
  }
  /**
   * Gets the list cache value for `key`.
   *
   * @private
   * @name get
   * @memberOf ListCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */


  function listCacheGet(key) {
    var data = this.__data__,
        index = assocIndexOf(data, key);
    return index < 0 ? undefined : data[index][1];
  }
  /**
   * Checks if a list cache value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf ListCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */


  function listCacheHas(key) {
    return assocIndexOf(this.__data__, key) > -1;
  }
  /**
   * Sets the list cache `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf ListCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the list cache instance.
   */


  function listCacheSet(key, value) {
    var data = this.__data__,
        index = assocIndexOf(data, key);

    if (index < 0) {
      data.push([key, value]);
    } else {
      data[index][1] = value;
    }

    return this;
  } // Add methods to `ListCache`.


  ListCache.prototype.clear = listCacheClear;
  ListCache.prototype['delete'] = listCacheDelete;
  ListCache.prototype.get = listCacheGet;
  ListCache.prototype.has = listCacheHas;
  ListCache.prototype.set = listCacheSet;
  /**
   * Creates a map cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */

  function MapCache(entries) {
    var index = -1,
        length = entries ? entries.length : 0;
    this.clear();

    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  /**
   * Removes all key-value entries from the map.
   *
   * @private
   * @name clear
   * @memberOf MapCache
   */


  function mapCacheClear() {
    this.__data__ = {
      hash: new Hash(),
      map: new (Map$1 || ListCache)(),
      string: new Hash()
    };
  }
  /**
   * Removes `key` and its value from the map.
   *
   * @private
   * @name delete
   * @memberOf MapCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */


  function mapCacheDelete(key) {
    return getMapData(this, key)['delete'](key);
  }
  /**
   * Gets the map value for `key`.
   *
   * @private
   * @name get
   * @memberOf MapCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */


  function mapCacheGet(key) {
    return getMapData(this, key).get(key);
  }
  /**
   * Checks if a map value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf MapCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */


  function mapCacheHas(key) {
    return getMapData(this, key).has(key);
  }
  /**
   * Sets the map `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf MapCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the map cache instance.
   */


  function mapCacheSet(key, value) {
    getMapData(this, key).set(key, value);
    return this;
  } // Add methods to `MapCache`.


  MapCache.prototype.clear = mapCacheClear;
  MapCache.prototype['delete'] = mapCacheDelete;
  MapCache.prototype.get = mapCacheGet;
  MapCache.prototype.has = mapCacheHas;
  MapCache.prototype.set = mapCacheSet;
  /**
   * Gets the index at which the `key` is found in `array` of key-value pairs.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} key The key to search for.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */

  function assocIndexOf(array, key) {
    var length = array.length;

    while (length--) {
      if (eq(array[length][0], key)) {
        return length;
      }
    }

    return -1;
  }
  /**
   * The base implementation of `_.get` without support for default values.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @returns {*} Returns the resolved value.
   */


  function baseGet(object, path) {
    path = isKey(path, object) ? [path] : castPath(path);
    var index = 0,
        length = path.length;

    while (object != null && index < length) {
      object = object[toKey(path[index++])];
    }

    return index && index == length ? object : undefined;
  }
  /**
   * The base implementation of `_.isNative` without bad shim checks.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a native function,
   *  else `false`.
   */


  function baseIsNative(value) {
    if (!isObject(value) || isMasked(value)) {
      return false;
    }

    var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
    return pattern.test(toSource(value));
  }
  /**
   * The base implementation of `_.toString` which doesn't convert nullish
   * values to empty strings.
   *
   * @private
   * @param {*} value The value to process.
   * @returns {string} Returns the string.
   */


  function baseToString(value) {
    // Exit early for strings to avoid a performance hit in some environments.
    if (typeof value === 'string') {
      return value;
    }

    if (isSymbol(value)) {
      return symbolToString ? symbolToString.call(value) : '';
    }

    var result = value + '';
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
  }
  /**
   * Casts `value` to a path array if it's not one.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {Array} Returns the cast property path array.
   */


  function castPath(value) {
    return isArray(value) ? value : stringToPath(value);
  }
  /**
   * Gets the data for `map`.
   *
   * @private
   * @param {Object} map The map to query.
   * @param {string} key The reference key.
   * @returns {*} Returns the map data.
   */


  function getMapData(map, key) {
    var data = map.__data__;
    return isKeyable(key) ? data[typeof key === 'string' ? 'string' : 'hash'] : data.map;
  }
  /**
   * Gets the native function at `key` of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {string} key The key of the method to get.
   * @returns {*} Returns the function if it's native, else `undefined`.
   */


  function getNative(object, key) {
    var value = getValue(object, key);
    return baseIsNative(value) ? value : undefined;
  }
  /**
   * Checks if `value` is a property name and not a property path.
   *
   * @private
   * @param {*} value The value to check.
   * @param {Object} [object] The object to query keys on.
   * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
   */


  function isKey(value, object) {
    if (isArray(value)) {
      return false;
    }

    var type = _typeof(value);

    if (type == 'number' || type == 'symbol' || type == 'boolean' || value == null || isSymbol(value)) {
      return true;
    }

    return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
  }
  /**
   * Checks if `value` is suitable for use as unique object key.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
   */


  function isKeyable(value) {
    var type = _typeof(value);

    return type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean' ? value !== '__proto__' : value === null;
  }
  /**
   * Checks if `func` has its source masked.
   *
   * @private
   * @param {Function} func The function to check.
   * @returns {boolean} Returns `true` if `func` is masked, else `false`.
   */


  function isMasked(func) {
    return !!maskSrcKey && maskSrcKey in func;
  }
  /**
   * Converts `string` to a property path array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the property path array.
   */


  var stringToPath = memoize(function (string) {
    string = toString(string);
    var result = [];

    if (reLeadingDot.test(string)) {
      result.push('');
    }

    string.replace(rePropName, function (match, number, quote, string) {
      result.push(quote ? string.replace(reEscapeChar, '$1') : number || match);
    });
    return result;
  });
  /**
   * Converts `value` to a string key if it's not a string or symbol.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {string|symbol} Returns the key.
   */

  function toKey(value) {
    if (typeof value === 'string' || isSymbol(value)) {
      return value;
    }

    var result = value + '';
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
  }
  /**
   * Converts `func` to its source code.
   *
   * @private
   * @param {Function} func The function to process.
   * @returns {string} Returns the source code.
   */


  function toSource(func) {
    if (func != null) {
      try {
        return funcToString.call(func);
      } catch (e) {}

      try {
        return func + '';
      } catch (e) {}
    }

    return '';
  }
  /**
   * Creates a function that memoizes the result of `func`. If `resolver` is
   * provided, it determines the cache key for storing the result based on the
   * arguments provided to the memoized function. By default, the first argument
   * provided to the memoized function is used as the map cache key. The `func`
   * is invoked with the `this` binding of the memoized function.
   *
   * **Note:** The cache is exposed as the `cache` property on the memoized
   * function. Its creation may be customized by replacing the `_.memoize.Cache`
   * constructor with one whose instances implement the
   * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
   * method interface of `delete`, `get`, `has`, and `set`.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Function
   * @param {Function} func The function to have its output memoized.
   * @param {Function} [resolver] The function to resolve the cache key.
   * @returns {Function} Returns the new memoized function.
   * @example
   *
   * var object = { 'a': 1, 'b': 2 };
   * var other = { 'c': 3, 'd': 4 };
   *
   * var values = _.memoize(_.values);
   * values(object);
   * // => [1, 2]
   *
   * values(other);
   * // => [3, 4]
   *
   * object.a = 2;
   * values(object);
   * // => [1, 2]
   *
   * // Modify the result cache.
   * values.cache.set(object, ['a', 'b']);
   * values(object);
   * // => ['a', 'b']
   *
   * // Replace `_.memoize.Cache`.
   * _.memoize.Cache = WeakMap;
   */


  function memoize(func, resolver) {
    if (typeof func !== 'function' || resolver && typeof resolver !== 'function') {
      throw new TypeError(FUNC_ERROR_TEXT);
    }

    var memoized = function memoized() {
      var args = arguments,
          key = resolver ? resolver.apply(this, args) : args[0],
          cache = memoized.cache;

      if (cache.has(key)) {
        return cache.get(key);
      }

      var result = func.apply(this, args);
      memoized.cache = cache.set(key, result);
      return result;
    };

    memoized.cache = new (memoize.Cache || MapCache)();
    return memoized;
  } // Assign cache to `_.memoize`.


  memoize.Cache = MapCache;
  /**
   * Performs a
   * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * comparison between two values to determine if they are equivalent.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   * @example
   *
   * var object = { 'a': 1 };
   * var other = { 'a': 1 };
   *
   * _.eq(object, object);
   * // => true
   *
   * _.eq(object, other);
   * // => false
   *
   * _.eq('a', 'a');
   * // => true
   *
   * _.eq('a', Object('a'));
   * // => false
   *
   * _.eq(NaN, NaN);
   * // => true
   */

  function eq(value, other) {
    return value === other || value !== value && other !== other;
  }
  /**
   * Checks if `value` is classified as an `Array` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array, else `false`.
   * @example
   *
   * _.isArray([1, 2, 3]);
   * // => true
   *
   * _.isArray(document.body.children);
   * // => false
   *
   * _.isArray('abc');
   * // => false
   *
   * _.isArray(_.noop);
   * // => false
   */


  var isArray = Array.isArray;
  /**
   * Checks if `value` is classified as a `Function` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a function, else `false`.
   * @example
   *
   * _.isFunction(_);
   * // => true
   *
   * _.isFunction(/abc/);
   * // => false
   */

  function isFunction(value) {
    // The use of `Object#toString` avoids issues with the `typeof` operator
    // in Safari 8-9 which returns 'object' for typed array and other constructors.
    var tag = isObject(value) ? objectToString.call(value) : '';
    return tag == funcTag || tag == genTag;
  }
  /**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */


  function isObject(value) {
    var type = _typeof(value);

    return !!value && (type == 'object' || type == 'function');
  }
  /**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */


  function isObjectLike(value) {
    return !!value && _typeof(value) === 'object';
  }
  /**
   * Checks if `value` is classified as a `Symbol` primitive or object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
   * @example
   *
   * _.isSymbol(Symbol.iterator);
   * // => true
   *
   * _.isSymbol('abc');
   * // => false
   */


  function isSymbol(value) {
    return _typeof(value) === 'symbol' || isObjectLike(value) && objectToString.call(value) == symbolTag;
  }
  /**
   * Converts `value` to a string. An empty string is returned for `null`
   * and `undefined` values. The sign of `-0` is preserved.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to process.
   * @returns {string} Returns the string.
   * @example
   *
   * _.toString(null);
   * // => ''
   *
   * _.toString(-0);
   * // => '-0'
   *
   * _.toString([1, 2, 3]);
   * // => '1,2,3'
   */


  function toString(value) {
    return value == null ? '' : baseToString(value);
  }
  /**
   * Gets the value at `path` of `object`. If the resolved value is
   * `undefined`, the `defaultValue` is returned in its place.
   *
   * @static
   * @memberOf _
   * @since 3.7.0
   * @category Object
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @param {*} [defaultValue] The value returned for `undefined` resolved values.
   * @returns {*} Returns the resolved value.
   * @example
   *
   * var object = { 'a': [{ 'b': { 'c': 3 } }] };
   *
   * _.get(object, 'a[0].b.c');
   * // => 3
   *
   * _.get(object, ['a', '0', 'b', 'c']);
   * // => 3
   *
   * _.get(object, 'a.b.c', 'default');
   * // => 'default'
   */


  function get(object, path, defaultValue) {
    var result = object == null ? undefined : baseGet(object, path);
    return result === undefined ? defaultValue : result;
  }

  var eventPreffix = '__event_';
  var rootScopeKey = '__root_';
  var componentPath = 'componentPath';
  var scopeMap = {};
  var pageExtraFns = ['onPullDownRefresh', 'onReachBottom', 'onShareAppMessage', 'onPageScroll', 'onTabItemTap'];

  function processEvent(pagePath, eventHandlerName, obj) {
    var newEventHandlerName = eventHandlerName.replace(eventPreffix, '');

    if (obj[newEventHandlerName]) {
      return;
    }

    obj[newEventHandlerName] = function (event) {
      if (event) {
        event.preventDefault = function () {};

        event.stopPropagation = function () {};

        Object.assign(event.target, event.detail);
        Object.assign(event.currentTarget, event.detail);
      }

      var dataset = event.currentTarget.dataset;
      var theComponent = scopeMap[pagePath][dataset[componentPath] || rootScopeKey];
      var scope = theComponent;
      var bindArgs = {};
      var componentClassName = dataset['componentClass'];
      var newEventHandlerNameLower = newEventHandlerName.toLocaleLowerCase();
      Object.keys(dataset).forEach(function (key) {
        var keyLower = key.toLocaleLowerCase();

        if (keyLower.indexOf('event') === 0) {
          keyLower = keyLower.replace('event', '');
          keyLower = componentClassName ? "".concat(componentClassName, "__").concat(keyLower) : keyLower;
          keyLower = keyLower.toLocaleLowerCase();

          if (keyLower.indexOf(newEventHandlerNameLower) >= 0) {
            var argName = keyLower.replace(newEventHandlerNameLower, '');
            bindArgs[argName] = dataset[key];
          }
        }
      });

      if (!isEmptyObject(bindArgs)) {
        if (bindArgs['scope'] !== 'this') {
          scope = bindArgs['scope'];
        }

        delete bindArgs['scope'];
        var realArgs = Object.keys(bindArgs).sort().map(function (key) {
          return bindArgs[key];
        });
        realArgs.push(event);

        var newHandler = function newHandler() {
          return theComponent[eventHandlerName].apply(scope, realArgs);
        };

        newHandler();
      } else {
        if (dataset[componentPath]) {
          scope = scopeMap[pagePath][dataset[componentPath] || rootScopeKey];
        }

        theComponent[eventHandlerName].call(scope, event);
      }
    };
  }

  function initPage(weappPageConf, page, options) {
    var pagePath = options.path;
    scopeMap[pagePath] = scopeMap[pagePath] || {};

    function recurrenceComponent(weappPageConf, component, path) {
      component.$path = path || '';
      component.props.$path = component.$path;

      if (path) {
        scopeMap[pagePath][path] = component;
      } else {
        scopeMap[pagePath][rootScopeKey] = component;
      }

      if (!isEmptyObject(component.$components)) {
        Object.getOwnPropertyNames(component.$components).forEach(function (name) {
          var _class = component.$components[name];
          var comPath = "".concat(component.$path, "$$").concat(name);

          var _props = (component.$props || {})[name] || {};

          var props = typeof _props === 'function' ? _props.call(component) : _props;
          var child = new _class(props);
          component.$$components[name] = child;
          recurrenceComponent(weappPageConf, child, comPath);
        });
      }

      for (var k in component) {
        if (k.indexOf(eventPreffix) >= 0) {
          processEvent(pagePath, k, weappPageConf);
        }
      }

      var prototypeChain = getPrototypeChain(component);
      prototypeChain.forEach(function (item) {
        Object.getOwnPropertyNames(item).forEach(function (fn) {
          if (fn.indexOf(eventPreffix) >= 0) {
            processEvent(pagePath, fn, weappPageConf);
          }
        });
      });
      return weappPageConf;
    }

    return recurrenceComponent(weappPageConf, page);
  }

  function processDynamicComponents(page) {
    var pagePath = page.path;
    scopeMap[pagePath] = scopeMap[pagePath] || {};

    function recursiveDynamicComponents(component) {
      if (component.$dynamicComponents && !isEmptyObject(component.$dynamicComponents)) {
        component.$$dynamicComponents = component.$$dynamicComponents || {};
        Object.getOwnPropertyNames(component.$dynamicComponents).forEach(function (name) {
          var dynamicComponetFn = component.$dynamicComponents[name];
          var loopRes = dynamicComponetFn();
          var stateName = loopRes.stateName;
          var loopComponents = loopRes.loopComponents;
          var stateData = get(component.state, stateName);
          recurrence(loopComponents, stateData);

          function recurrence(loopComponents, stateData) {
            loopComponents.forEach(function (item) {
              var _class = item.path;
              var components = item.components;
              var children = item.children;
              var subscript = item.subscript;
              stateData = subscript ? get(stateData, subscript) : stateData;

              if (!stateData) {
                return;
              }

              if (components && components.length) {
                components.forEach(function (item, index) {
                  var comPath = "".concat(component.$path, "$$").concat(item.fn);
                  var child;
                  Object.getOwnPropertyNames(component.$$dynamicComponents).forEach(function (c) {
                    if (c === comPath) {
                      child = component.$$dynamicComponents[c];
                    }
                  });

                  if (!child) {
                    child = new _class(item.body);
                    child.$path = comPath;
                    child.props.$path = comPath;

                    child._init(component.$scope);

                    child._initData(component.$root || component, component);

                    componentTrigger(child, 'componentWillMount');
                  }

                  if (stateData) {
                    stateData[index] = Object.assign({}, _objectSpread({}, stateData[index]), child.props, child.state);
                  }

                  component.$$dynamicComponents[comPath] = child;
                  scopeMap[pagePath][comPath] = child;

                  for (var k in child) {
                    if (k.indexOf(eventPreffix) >= 0) {
                      processEvent(pagePath, k, component);
                    }
                  }

                  var prototypeChain = getPrototypeChain(child);
                  prototypeChain.forEach(function (item) {
                    Object.getOwnPropertyNames(item).forEach(function (fn) {
                      if (fn.indexOf(eventPreffix) >= 0) {
                        processEvent(pagePath, fn, component);
                      }
                    });
                  });

                  if (item.children && item.children.length) {
                    recurrence(item.children, stateData[index]);
                  }

                  recursiveDynamicComponents(item);
                });
              }

              if (children && children.length) {
                stateData.forEach(function (item) {
                  recurrence(children, item);
                });
              }
            });
          }
        });
      }
    }

    recursiveDynamicComponents(page);
  }

  function componentTrigger(component, key) {
    if (key === 'componentWillUnmount') {
      component._dirty = true;
      component._disable = true;
    }

    Object.getOwnPropertyNames(component.$$components || {}).forEach(function (name) {
      componentTrigger(component.$$components[name], key);
    });
    component[key] && typeof component[key] === 'function' && component[key]();

    if (key === 'componentWillMount') {
      if (component.$isComponent) {
        component.$router.params = component.$root.$router.params;
      }

      component._dirty = false;
      component._disable = false;
      component.state = component.getState();
      component.forceUpdate();
    }
  }

  function createPage(PageClass, options) {
    var page = new PageClass();
    page.$isComponent = false;
    page.path = options.path;
    var weappPageConf = {
      onLoad: function onLoad(options) {
        page._init(this);

        page.$router.params = options;
        componentTrigger(page, 'componentWillMount');
      },
      onReady: function onReady() {
        componentTrigger(page, 'componentDidMount');
      },
      onShow: function onShow() {
        componentTrigger(page, 'componentDidShow');
      },
      onHide: function onHide() {
        componentTrigger(page, 'componentDidHide');
      },
      onUnload: function onUnload() {
        componentTrigger(page, 'componentWillUnmount');
      },
      _setData: function _setData(data, cb, isRoot) {
        if (isRoot) {
          var filterData = {};

          for (var k in data) {
            if (typeof data[k] !== 'undefined') {
              filterData[k] = data[k];
            }
          }

          this.setData(filterData, function () {
            cb && cb();
          });
        }
      }
    };
    var weappPageConfEvents = initPage(weappPageConf, page, options);

    page._initData();

    processDynamicComponents(page);
    pageExtraFns.forEach(function (fn) {
      if (typeof page[fn] === 'function') {
        weappPageConf[fn] = page[fn].bind(page);
      }
    });
    return Object.assign(weappPageConfEvents, {
      data: page.$data
    });
  }

  function updateComponent(component, update) {
    var props = component.props;
    var state = component.getState();

    if (component._createData) {
      state = component._createData(state);
    }

    state.__data && (state.__data.$path = component.$path);
    var prevProps = component.prevProps || props;
    var prevState = component.prevState || state;
    component.props = prevProps;
    var skip = false;

    if (typeof component.shouldComponentUpdate === 'function' && component.shouldComponentUpdate(props, state) === false) {
      skip = true;
    } else if (typeof component.componentWillUpdate === 'function') {
      component.componentWillUpdate(props, state);
    }

    component.props = props;
    component.state = state;
    component._dirty = false;

    if (!skip) {
      for (var k in component.$props) {
        var childProps = component.$props[k].call(component);
        var subComponent = component.$$components[k];
        var newChildProps = Object.assign(subComponent.props, childProps);
        component._disable = true;

        if (subComponent.componentWillReceiveProps) {
          subComponent.componentWillReceiveProps(newChildProps);
        }

        component._disable = false;
        subComponent.props = newChildProps;
        updateComponent(subComponent, false);
      }

      var propsCopy = {};
      Object.keys(component.props).forEach(function (item) {
        if (typeof component.props[item] !== 'function') {
          propsCopy[item] = component.props[item];
        }
      });
      Object.assign(component.$data, component.state, propsCopy);

      if (component.componentDidUpdate) {
        component.componentDidUpdate(prevProps, prevState);
      }

      doUpdate(component, update);
    }

    component.prevProps = component.props;
    component.prevState = component.state;
  }

  function doUpdate(component, update) {
    var $data = component.$root ? component.$root.$data : component.$data;

    if (update) {
      processDynamicComponents(component.$root || component);
    }

    component.$scope._setData(_objectSpread({}, $data), function () {
      if (component._pendingCallbacks) {
        while (component._pendingCallbacks.length) {
          component._pendingCallbacks.pop().call(component);
        }
      }
    }, update);
  }

  var items = [];
  function enqueueRender(component) {
    // tslint:disable-next-line:no-conditional-assignment
    if (!component._dirty && (component._dirty = true) && items.push(component) === 1) {
      nextTick(rerender);
    }
  }
  function rerender() {
    var p;
    var list = items;
    items = []; // tslint:disable-next-line:no-conditional-assignment

    while (p = list.pop()) {
      if (p._dirty) {
        updateComponent(p, true);
      }
    }
  }

  var Component =
  /*#__PURE__*/
  function () {
    function Component(props) {
      _classCallCheck(this, Component);

      Object.defineProperty(this, "$components", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: {}
      });
      Object.defineProperty(this, "$$components", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: {}
      });
      Object.defineProperty(this, "$router", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: {
          $params: {}
        }
      });
      Object.defineProperty(this, "$path", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: ''
      });
      Object.defineProperty(this, "$name", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: ''
      });
      Object.defineProperty(this, "$isComponent", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: true
      });
      Object.defineProperty(this, "$props", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: {}
      });
      Object.defineProperty(this, "nextProps", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: {}
      });
      Object.defineProperty(this, "_dirty", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: true
      });
      Object.defineProperty(this, "_disable", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: true
      });
      Object.defineProperty(this, "_pendingStates", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: []
      });
      Object.defineProperty(this, "_pendingCallbacks", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: []
      });
      this.state = {};
      this.props = props || {};
    }

    _createClass(Component, [{
      key: "_initData",
      value: function _initData($root, $parent) {
        var _this = this;

        this.$app = getApp();
        this.$root = $root || null;
        this.$parent = $parent || null;
        this.defaultData = {};
        this.$data = $parent ? $parent.$data : {};
        var path = this.$path.split('$$').pop();
        this.$data["$$".concat(path)] = this.$data["$$".concat(path)] || {};
        this.$data = this.$data["$$".concat(path)];

        for (var k in this.state) {
          this.$data[k] = this.state[k];
        }

        if (this.props) {
          for (var _k in this.props) {
            if (typeof this.props[_k] !== 'function') {
              this.$data[_k] = this.props[_k];
            }
          }
        }

        if (this.$$components && !isEmptyObject(this.$$components)) {
          Object.getOwnPropertyNames(this.$$components).forEach(function (name) {
            _this.$$components[name]._initData(_this.$root || _this, _this);
          });
        }

        if (this.$$dynamicComponents && !isEmptyObject(this.$$dynamicComponents)) {
          Object.getOwnPropertyNames(this.$$dynamicComponents).forEach(function (name) {
            _this.$$dynamicComponents[name]._initData(_this.$root || _this, _this);
          });
        }
      }
    }, {
      key: "_init",
      value: function _init(scope) {
        var _this2 = this;

        this.$scope = scope;
        this.$app = getApp();

        if (this.$$components && !isEmptyObject(this.$$components)) {
          Object.getOwnPropertyNames(this.$$components).forEach(function (name) {
            _this2.$$components[name]._init(_this2.$scope);
          });
        }

        if (this.$$dynamicComponents && !isEmptyObject(this.$$dynamicComponents)) {
          Object.getOwnPropertyNames(this.$$dynamicComponents).forEach(function (name) {
            _this2.$$dynamicComponents[name]._init(_this2.$scope);
          });
        }
      } // rewrite when compile

    }, {
      key: "_createData",
      value: function _createData() {
        return this.state;
      }
    }, {
      key: "setState",
      value: function setState(state, callback) {
        if (state) {
          (this._pendingStates = this._pendingStates || []).push(state);
        }

        if (typeof callback === 'function') {
          (this._pendingCallbacks = this._pendingCallbacks || []).push(callback);
        }

        if (!this._disable) {
          enqueueRender(this);
        }
      }
    }, {
      key: "getState",
      value: function getState() {
        var _this3 = this;

        var _pendingStates = this._pendingStates,
            state = this.state,
            props = this.props;
        var stateClone = Object.assign({}, state);
        delete stateClone.__data;

        if (!_pendingStates.length) {
          return stateClone;
        }

        var queue = _pendingStates.concat();

        this._pendingStates.length = 0;
        queue.forEach(function (nextState) {
          if (typeof nextState === 'function') {
            nextState = nextState.call(_this3, stateClone, props);
          }

          Object.assign(stateClone, nextState);
        });
        return stateClone;
      }
    }, {
      key: "forceUpdate",
      value: function forceUpdate(callback) {
        if (typeof callback === 'function') {
          (this._pendingCallbacks = this._pendingCallbacks || []).push(callback);
        }

        updateComponent(this, true);
      }
    }]);

    return Component;
  }();

  Object.defineProperty(Component, "defaultProps", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: {}
  });

  /**
   * WXML节点信息API
   * @return {Object} SelectorQuery 对象实例
   */
  function queryBat(queue, cb) {
    var res = [];
    var cached = {};
    queue.forEach(function (item) {
      var selector = item.selector,
          single = item.single,
          fields = item.fields;
      var el = null;

      if (single) {
        if (cached[selector] && cached[selector].single) {
          el = cached[selector].el;
        } else {
          el = document.querySelector(selector);
          cached[selector] = {
            single: single,
            el: el
          };
        }

        res.push(filter(fields, el, selector));
      } else {
        if (cached[selector] && !cached[selector].single) {
          el = cached[selector].el;
        } else {
          el = Array.from(document.querySelectorAll(selector));
          cached[selector] = {
            single: single,
            el: el
          };
        }

        res.push(el.map(function (dom) {
          return filter(fields, dom);
        }));
      }
    });
    cb(res);
  }

  function filter(fields, dom, selector) {
    if (!dom) return null;
    var id = fields.id,
        dataset = fields.dataset,
        rect = fields.rect,
        size = fields.size,
        scrollOffset = fields.scrollOffset,
        _fields$properties = fields.properties,
        properties = _fields$properties === void 0 ? [] : _fields$properties;

    var _dom$getBoundingClien = dom.getBoundingClientRect(),
        left = _dom$getBoundingClien.left,
        right = _dom$getBoundingClien.right,
        top = _dom$getBoundingClien.top,
        bottom = _dom$getBoundingClien.bottom,
        width = _dom$getBoundingClien.width,
        height = _dom$getBoundingClien.height;

    var isViewport = selector === 'html';
    var res = {};
    if (id) res.id = dom.id;
    if (dataset) res.dataset = Object.assign({}, dom.dataset);

    if (rect) {
      if (!isViewport) {
        res.left = left;
        res.right = right;
        res.top = top;
        res.bottom = bottom;
      } else {
        res.left = res.right = res.top = res.bottom = 0;
      }
    }

    if (size) {
      if (!isViewport) {
        res.width = width;
        res.height = height;
      } else {
        res.width = dom.clientWidth;
        res.height = dom.clientHeight;
      }
    }

    if (scrollOffset) {
      res.scrollLeft = dom.scrollLeft;
      res.scrollTop = dom.scrollTop;
    }

    if (properties.length) {
      properties.forEach(function (prop) {
        res[prop] = dom.getAttribute(prop);
      });
    }

    return res;
  }

  var Query =
  /*#__PURE__*/
  function () {
    function Query() {
      _classCallCheck(this, Query);

      this._defaultWebviewId = null;
      this._webviewId = null;
      this._queue = [];
      this._queueCb = [];
      this._component = null;
    }

    _createClass(Query, [{
      key: "in",
      value: function _in(component) {
        this._component = component;
        return this;
      }
    }, {
      key: "select",
      value: function select(selector) {
        // 小程序里跨自定义组件的后代选择器 '>>>' 在 h5 替换为普通后代选择器 '>'
        selector = selector.replace('>>>', '>');
        return new NodesRef(selector, this, true);
      }
    }, {
      key: "selectAll",
      value: function selectAll(selector) {
        // 小程序里跨自定义组件的后代选择器 '>>>' 在 h5 替换为普通后代选择器 '>'
        selector = selector.replace('>>>', '>');
        return new NodesRef(selector, this, false);
      }
    }, {
      key: "selectViewport",
      value: function selectViewport() {
        return new NodesRef('html', this, true);
      }
    }, {
      key: "exec",
      value: function exec(cb) {
        var _this = this;

        queryBat(this._queue, function (res) {
          var _queueCb = _this._queueCb;
          res.forEach(function (item, index) {
            typeof _queueCb[index] === 'function' && _queueCb[index].call(_this, item);
          });
          typeof cb === 'function' && cb.call(_this, res);
        });
      }
    }, {
      key: "_push",
      value: function _push(selector, component, single, fields) {
        var callback = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;

        this._queue.push({
          component: component,
          selector: selector,
          single: single,
          fields: fields
        });

        this._queueCb.push(callback);
      }
    }]);

    return Query;
  }();

  var NodesRef =
  /*#__PURE__*/
  function () {
    function NodesRef(selector, querySelectorQuery, single) {
      _classCallCheck(this, NodesRef);

      this._component = querySelectorQuery._component;
      this._selector = selector;
      this._selectorQuery = querySelectorQuery;
      this._single = single;
    }

    _createClass(NodesRef, [{
      key: "boundingClientRect",
      value: function boundingClientRect(cb) {
        var _selector = this._selector,
            _component = this._component,
            _single = this._single,
            _selectorQuery = this._selectorQuery;

        _selectorQuery._push(_selector, _component, _single, {
          id: !0,
          dataset: !0,
          rect: !0,
          size: !0
        }, cb);

        return _selectorQuery;
      }
    }, {
      key: "scrollOffset",
      value: function scrollOffset(cb) {
        var _selector = this._selector,
            _component = this._component,
            _single = this._single,
            _selectorQuery = this._selectorQuery;

        _selectorQuery._push(_selector, _component, _single, {
          id: !0,
          dataset: !0,
          scrollOffset: !0
        }, cb);

        return _selectorQuery;
      }
    }, {
      key: "fields",
      value: function fields(_fields, cb) {
        var _selector = this._selector,
            _component = this._component,
            _single = this._single,
            _selectorQuery = this._selectorQuery;
        var id = _fields.id,
            dataset = _fields.dataset,
            rect = _fields.rect,
            size = _fields.size,
            scrollOffset = _fields.scrollOffset,
            _fields$properties2 = _fields.properties,
            properties = _fields$properties2 === void 0 ? [] : _fields$properties2;

        _selectorQuery._push(_selector, _component, _single, {
          id: id,
          dataset: dataset,
          rect: rect,
          size: size,
          scrollOffset: scrollOffset,
          properties: properties
        }, cb);

        return _selectorQuery;
      }
    }]);

    return NodesRef;
  }();

  function createSelectorQuery() {
    return new Query();
  }

  var env = getEnv();

  function setStorage() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var key = options.key,
        data = options.data,
        success = options.success,
        fail = options.fail,
        complete = options.complete;
    var res = {
      errMsg: 'getStorage:ok'
    };

    if (typeof key !== 'string') {
      var e = new Error("setStorage:fail parameter error: parameter should be String instead of ".concat(_typeof(key)));
      res.errMsg = e.message;
      fail && fail(res);
      complete && complete(res);
      return Promise.reject(e);
    }

    setStorageSync(key, data);
    success && success(res);
    complete && complete(res);
    return Promise.resolve(res);
  }

  function setStorageSync(key) {
    var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    if (typeof key !== 'string') throw new Error("setStorageSync:fail parameter error: parameter should be String instead of ".concat(_typeof(key)));

    var type = _typeof(data);

    var obj = {};

    if (type === 'symbol') {
      obj = {
        data: ''
      };
    } else {
      obj = {
        data: data
      };
    }

    if (env === ENV_TYPE.WEAPP) {
      wx.setStorageSync(key, obj);
    } else {
      localStorage.setItem(key, JSON.stringify(obj));
    }
  }

  function getStorage() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var key = options.key,
        success = options.success,
        fail = options.fail,
        complete = options.complete;
    var res = {
      errMsg: 'getStorage:ok'
    };

    if (typeof key !== 'string') {
      var e = new Error("getStorage:fail parameter error: parameter should be String instead of ".concat(_typeof(key)));
      res.errMsg = e.message;
      fail && fail(res);
      complete && complete(res);
      return Promise.reject(e);
    }

    res.data = getStorageSync(key);
    success && success(res);
    complete && complete(res);
    return Promise.resolve(res);
  }

  function getStorageSync(key) {
    if (typeof key !== 'string') throw new Error("getStorageSync:fail parameter error: parameter should be String instead of ".concat(_typeof(key)));
    var res;

    if (env === ENV_TYPE.WEAPP) {
      res = wx.getStorageSync(key);
    } else {
      res = JSON.parse(localStorage.getItem(key));
    } // 只返回使用 Taro.setStorage API 存储的数据


    if (res && res.data) return res.data;
    return '';
  }

  function getStorageInfo() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var success = options.success,
        complete = options.complete;
    var res = {
      errMsg: 'getStorageInfo:ok'
    };
    var info = getStorageInfoSync();
    Object.assign(res, info);
    success && success(res);
    complete && complete(res);
    return Promise.resolve(res);
  }

  function getStorageInfoSync() {
    if (env === ENV_TYPE.WEAPP) {
      return wx.getStorageInfoSync();
    }

    var res = {};
    res.keys = Object.keys(localStorage);
    res.limitSize = null;
    res.currentSize = null;
    return res;
  }

  function removeStorage() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var key = options.key,
        success = options.success,
        fail = options.fail,
        complete = options.complete;
    var res = {
      errMsg: 'removeStorage:ok'
    };

    if (typeof key !== 'string') {
      var e = new Error("removeStorage:fail parameter error: parameter should be String instead of ".concat(_typeof(key)));
      res.errMsg = e.message;
      fail && fail(res);
      complete && complete(res);
      return Promise.reject(e);
    }

    removeStorageSync(key);
    success && success(res);
    complete && complete(res);
    return Promise.resolve(res);
  }

  function removeStorageSync(key) {
    if (typeof key !== 'string') throw new Error("removeStorageSync:fail parameter error: parameter should be String instead of ".concat(_typeof(key)));

    if (env === ENV_TYPE.WEAPP) {
      wx.removeStorageSync(key);
    } else {
      localStorage.removeItem(key);
    }
  }

  function clearStorage() {
    if (env === ENV_TYPE.WEAPP) {
      wx.clearStorage();
    } else {
      localStorage.clear();
    }
  }

  var storage = /*#__PURE__*/Object.freeze({
    setStorage: setStorage,
    setStorageSync: setStorageSync,
    getStorage: getStorage,
    getStorageSync: getStorageSync,
    getStorageInfo: getStorageInfo,
    getStorageInfoSync: getStorageInfoSync,
    removeStorage: removeStorage,
    removeStorageSync: removeStorageSync,
    clearStorage: clearStorage,
    clearStorageSync: clearStorage
  });

  var env$1 = getEnv();
  var RequestQueue = {
    MAX_REQUEST: 5,
    queue: [],
    request: function request(options) {
      this.push(options);
      this.run();
    },
    push: function push(options) {
      this.queue.push(options);
    },
    run: function run() {
      var _this = this,
          _arguments = arguments;

      if (!this.queue.length) {
        return;
      }

      if (this.queue.length <= this.MAX_REQUEST) {
        var options = this.queue.shift();
        var completeFn = options.complete;

        options.complete = function () {
          completeFn && completeFn.apply(options, _toConsumableArray(_arguments));

          _this.run();
        };

        wx.request(options);
      }
    }
  };

  function request(options) {
    options = options || {};

    if (typeof options === 'string') {
      options = {
        url: options
      };
    }

    if (env$1 === ENV_TYPE.WEAPP) {
      var p = new Promise(function (resolve, reject) {
        options['success'] = function (res) {
          resolve(res);
        };

        options['fail'] = function (res) {
          reject(res);
        };

        RequestQueue.request(options);
      });
      return p;
    } else {
      var url = options.url;
      var params = {};
      params.body = options.data;
      params.headers = options.header;
      params.method = options.method;
      params.mode = options.mode;
      params.credentials = options.credentials;
      params.cache = options.cache;
      var res = {};
      return fetch(url, params).then(function (response) {
        res.statusCode = response.status;
        res.header = response.headers;

        if (options.responseType === 'arraybuffer') {
          return response.arrayBuffer();
        }

        if (options.dataType === 'json' || typeof options.dataType === 'undefined') {
          return response.json();
        }

        if (options.responseType === 'text') {
          return response.text();
        }

        return Promise.resolve(null);
      }).then(function (data) {
        res.data = data;
        return res;
      });
    }
  }

  function processApis(taro) {
    var onAndSyncApis = {
      onSocketOpen: true,
      onSocketError: true,
      onSocketMessage: true,
      onSocketClose: true,
      onBackgroundAudioPlay: true,
      onBackgroundAudioPause: true,
      onBackgroundAudioStop: true,
      onNetworkStatusChange: true,
      onAccelerometerChange: true,
      onCompassChange: true,
      onBluetoothAdapterStateChange: true,
      onBluetoothDeviceFound: true,
      onBLEConnectionStateChange: true,
      onBLECharacteristicValueChange: true,
      onBeaconUpdate: true,
      onBeaconServiceChange: true,
      onUserCaptureScreen: true,
      onHCEMessage: true,
      onGetWifiList: true,
      onWifiConnected: true,
      setStorageSync: true,
      getStorageSync: true,
      getStorageInfoSync: true,
      removeStorageSync: true,
      clearStorageSync: true,
      getSystemInfoSync: true,
      getExtConfigSync: true
    };
    var noPromiseApis = {
      // 媒体
      stopRecord: true,
      getRecorderManager: true,
      pauseVoice: true,
      stopVoice: true,
      pauseBackgroundAudio: true,
      stopBackgroundAudio: true,
      getBackgroundAudioManager: true,
      createAudioContext: true,
      createInnerAudioContext: true,
      createVideoContext: true,
      createCameraContext: true,
      navigateBack: true,
      // 位置
      createMapContext: true,
      // 设备
      canIUse: true,
      startAccelerometer: true,
      stopAccelerometer: true,
      startCompass: true,
      stopCompass: true,
      // 界面
      hideToast: true,
      hideLoading: true,
      showNavigationBarLoading: true,
      hideNavigationBarLoading: true,
      createAnimation: true,
      pageScrollTo: true,
      createSelectorQuery: true,
      createCanvasContext: true,
      createContext: true,
      drawCanvas: true,
      hideKeyboard: true,
      stopPullDownRefresh: true,
      // 拓展接口
      arrayBufferToBase64: true,
      base64ToArrayBuffer: true,
      getUpdateManager: true,
      createWorker: true
    };
    var otherApis = {
      // 网络
      uploadFile: true,
      downloadFile: true,
      connectSocket: true,
      sendSocketMessage: true,
      closeSocket: true,
      // 媒体
      chooseImage: true,
      previewImage: true,
      getImageInfo: true,
      saveImageToPhotosAlbum: true,
      startRecord: true,
      playVoice: true,
      getBackgroundAudioPlayerState: true,
      playBackgroundAudio: true,
      seekBackgroundAudio: true,
      chooseVideo: true,
      saveVideoToPhotosAlbum: true,
      // 文件
      saveFile: true,
      getFileInfo: true,
      getSavedFileList: true,
      getSavedFileInfo: true,
      removeSavedFile: true,
      openDocument: true,
      // 数据缓存
      setStorage: true,
      getStorage: true,
      getStorageInfo: true,
      removeStorage: true,
      clearStorage: true,
      // 导航
      navigateTo: true,
      redirectTo: true,
      switchTab: true,
      reLaunch: true,
      // 位置
      getLocation: true,
      chooseLocation: true,
      openLocation: true,
      // 设备
      getSystemInfo: true,
      getNetworkType: true,
      makePhoneCall: true,
      scanCode: true,
      setClipboardData: true,
      getClipboardData: true,
      openBluetoothAdapter: true,
      closeBluetoothAdapter: true,
      getBluetoothAdapterState: true,
      startBluetoothDevicesDiscovery: true,
      stopBluetoothDevicesDiscovery: true,
      getBluetoothDevices: true,
      getConnectedBluetoothDevices: true,
      createBLEConnection: true,
      closeBLEConnection: true,
      getBLEDeviceServices: true,
      getBLEDeviceCharacteristics: true,
      readBLECharacteristicValue: true,
      writeBLECharacteristicValue: true,
      notifyBLECharacteristicValueChange: true,
      startBeaconDiscovery: true,
      stopBeaconDiscovery: true,
      getBeacons: true,
      setScreenBrightness: true,
      getScreenBrightness: true,
      setKeepScreenOn: true,
      vibrateLong: true,
      vibrateShort: true,
      addPhoneContact: true,
      getHCEState: true,
      startHCE: true,
      stopHCE: true,
      sendHCEMessage: true,
      startWifi: true,
      stopWifi: true,
      connectWifi: true,
      getWifiList: true,
      setWifiList: true,
      getConnectedWifi: true,
      // 界面
      showToast: true,
      showLoading: true,
      showModal: true,
      showActionSheet: true,
      setNavigationBarTitle: true,
      setNavigationBarColor: true,
      setTabBarBadge: true,
      removeTabBarBadge: true,
      showTabBarRedDot: true,
      hideTabBarRedDot: true,
      setTabBarStyle: true,
      setTabBarItem: true,
      showTabBar: true,
      hideTabBar: true,
      setTopBarText: true,
      startPullDownRefresh: true,
      // 第三方平台
      getExtConfig: true,
      // 开放接口
      login: true,
      authorize: true,
      getUserInfo: true,
      requestPayment: true,
      showShareMenu: true,
      hideShareMenu: true,
      updateShareMenu: true,
      getShareInfo: true,
      chooseAddress: true,
      addCard: true,
      openCard: true,
      openSetting: true,
      getSetting: true,
      getWeRunData: true,
      navigateToMiniProgram: true,
      navigateBackMiniProgram: true,
      chooseInvoiceTitle: true,
      checkIsSupportSoterAuthentication: true,
      startSoterAuthentication: true,
      checkIsSoterEnrolledInDevice: true //

    };
    var weApis = Object.assign({}, onAndSyncApis, noPromiseApis, otherApis);
    Object.keys(weApis).forEach(function (key) {
      if (env$1 === ENV_TYPE.WEAPP) {
        if (!onAndSyncApis[key] && !noPromiseApis[key]) {
          taro[key] = function (options) {
            options = options || {};
            var task = null;
            var obj = Object.assign({}, options);

            if (typeof options === 'string') {
              return wx[key](options);
            }

            var p = new Promise(function (resolve, reject) {
              ['fail', 'success', 'complete'].forEach(function (k) {
                obj[k] = function (res) {
                  options[k] && options[k](res);

                  if (k === 'success') {
                    if (key === 'connectSocket') {
                      resolve(task);
                    } else {
                      resolve(res);
                    }
                  } else if (k === 'fail') {
                    reject(res);
                  }
                };
              });
              task = wx[key](obj);
            });

            if (key === 'uploadFile' || key === 'downloadFile') {
              p.progress = function (cb) {
                task.onProgressUpdate(cb);
                return p;
              };

              p.abort = function (cb) {
                cb && cb();
                task.abort();
                return p;
              };
            }

            return p;
          };
        } else {
          taro[key] = function () {
            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            return wx[key].apply(wx, args);
          };
        }
      } else {
        taro[key] = function () {
          console.log("\u6682\u65F6\u4E0D\u652F\u6301 ".concat(key));
        };
      }
    });
  }

  function initNativeApi(taro) {
    processApis(taro);
    taro.request = request;
    taro.createSelectorQuery = createSelectorQuery;
    Object.assign(taro, storage);
  }

  function createApp(AppClass) {
    initNativeApi(this);
    var app = new AppClass();
    var weappAppConf = {
      onLaunch: function onLaunch(options) {
        app.$app = this;
        app.$router = {
          params: options
        };

        if (app.componentWillMount) {
          app.componentWillMount();
        }

        if (app.componentDidMount) {
          app.componentDidMount();
        }
      },
      onShow: function onShow(options) {
        Object.assign(app.$router.params, options);

        if (app.componentDidShow) {
          app.componentDidShow();
        }
      },
      onHide: function onHide() {
        if (app.componentDidHide) {
          app.componentDidHide();
        }
      }
    };
    return Object.assign(weappAppConf, app);
  }

  function dynamicRecursive(component, param, data, stateName) {
    data = data || [];
    return param.map(function (paramItem) {
      var inData = paramItem.subscript ? data[paramItem.subscript] || [] : data;
      var res = {
        name: paramItem.name || '',
        path: paramItem.path || '',
        subscript: paramItem.subscript
      };
      res.components = [];

      if (res.name) {
        res.components = inData.map(function (d, index) {
          var res = {
            fn: "dy_".concat(stateName, "_").concat(paramItem.subscript, "_").concat(paramItem.name).concat(index),
            body: function (d) {
              return Object.assign({
                $name: "dy_".concat(stateName, "_").concat(paramItem.subscript, "_").concat(paramItem.name).concat(index)
              }, paramItem.args && paramItem.args.call(component, d, index));
            }(d)
          };

          if (paramItem.children && paramItem.children.length) {
            res.children = dynamicRecursive(component, paramItem.children, d, stateName);
          }

          return res;
        });
      } else if (paramItem.children && paramItem.children.length) {
        inData.map(function (d, index) {
          res.children = dynamicRecursive(component, paramItem.children, d, stateName);
        });
      }

      return res;
    });
  }

  /* eslint-disable camelcase */
  var index = {
    Component: Component,
    createApp: createApp,
    createPage: createPage,
    initNativeApi: initNativeApi,
    getEnv: getEnv,
    ENV_TYPE: ENV_TYPE,
    internal_safe_get: get,
    internal_dynamic_recursive: dynamicRecursive
  };

  exports.Component = Component;
  exports.createApp = createApp;
  exports.createPage = createPage;
  exports.initNativeApi = initNativeApi;
  exports.getEnv = getEnv;
  exports.ENV_TYPE = ENV_TYPE;
  exports.internal_safe_get = get;
  exports.internal_dynamic_recursive = dynamicRecursive;
  exports.default = index;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=taro.js.map
